#
# Conditional build:
%bcond_without	xen		# Xen support
%bcond_with	booke		# [PPC] build for BookE
%bcond_with	gamecube	# [PPC] build for GameCube

%ifarch x32
# Xen not (yet?) available
%undefine	with_xen
%endif
Summary:	Tool for starting new kernel without reboot
Summary(pl.UTF-8):	Narzędzie pozwalające załadować nowe jądro bez konieczności restartu
Name:		kexec-tools
Version:	2.0.30
Release:	2
License:	GPL v2
Group:		Applications/System
Source0:	https://www.kernel.org/pub/linux/utils/kernel/kexec/%{name}-%{version}.tar.xz
# Source0-md5:	3495ca3f3f74e5e4412511d7ed88be86
Source1:	kexec.init
Source2:	kexec.sysconfig
# from http://patchwork.openembedded.org/patch/90971/raw/ (stripped to remaining syscall part)
Patch0:		%{name}-x32.patch
URL:		https://www.kernel.org/pub/linux/utils/kernel/kexec/
BuildRequires:	autoconf >= 2.50
BuildRequires:	rpmbuild(macros) >= 1.228
BuildRequires:	tar >= 1:1.22
%{?with_xen:BuildRequires:	xen-devel >= 4.4}
BuildRequires:	xz
BuildRequires:	xz-devel
BuildRequires:	zlib-devel
Requires(post,preun):	/sbin/chkconfig
Requires:	rc-scripts >= 0.4.0.9
ExclusiveArch:	%{ix86} %{x8664} x32 alpha %{arm} aarch64 cris ia64 m68k mips ppc ppc64 s390 s390x sh
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_sbindir	/sbin

%description
kexec is a set of system calls that allows you to load another kernel
from the currently executing Linux kernel. The current implementation
has only been tested, and had the kinks worked out on x86, but the
generic code should work on any architecture.

%description -l pl.UTF-8
kexec to zestaw wywołań systemowych pozwalających załadować następne
jądro z poziomu aktualnie działającego jądra Linuksa. Aktualna
implementacja była testowana tylko na x86, ale ogólny kod powinien
działać na każdej architekturze.

%prep
%setup -q
%patch -P0 -p1

%build
%{__autoconf}
%configure \
	%{?with_booke:--with-booke} \
	%{?with_gamecube:--with-gamecube} \
	%{!?with_xen:--without-xen}
%{__make}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT/etc/{sysconfig,rc.d/init.d}

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

install %{SOURCE1} $RPM_BUILD_ROOT/etc/rc.d/init.d/kexec
cp -a %{SOURCE2} $RPM_BUILD_ROOT/etc/sysconfig/kexec

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/chkconfig --add kexec
%service kexec restart

%preun
if [ "$1" = "0" ]; then
	%service -q kexec stop
	/sbin/chkconfig --del kexec
fi

%files
%defattr(644,root,root,755)
%doc AUTHORS News TODO
%attr(754,root,root) /etc/rc.d/init.d/kexec
%config(noreplace) %verify(not md5 mtime size) /etc/sysconfig/kexec
%attr(755,root,root) %{_sbindir}/kexec
%attr(755,root,root) %{_sbindir}/vmcore-dmesg
%{_mandir}/man8/kexec.8*
%{_mandir}/man8/vmcore-dmesg.8*
%ifarch %{ix86} x32
%dir %{_libdir}/kexec-tools
# what is this anyway, is it needed on other arches?
%attr(755,root,root) %{_libdir}/kexec-tools/kexec_test
%endif
%changelog
* Sun Apr 13 2025 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/kexec-tools.git;a=log;h=master

* Sun Apr 13 2025 Jakub Bogusz <qboosh@pld-linux.org> 2061a73
- release 2 (xen 4.19)

* Mon Jan 27 2025 Jakub Bogusz <qboosh@pld-linux.org> 1b80ecb
- updated to 2.0.30

* Sat Jul 20 2024 Jakub Bogusz <qboosh@pld-linux.org> 178c969
- updated to 2.0.29

* Tue Apr 30 2024 Jakub Bogusz <qboosh@pld-linux.org> 1b814f3
- release 4 (xen 4.18)

* Fri Apr 05 2024 Jakub Bogusz <qboosh@pld-linux.org> 7893042
- release 3 (xen 4.17)

* Mon Mar 18 2024 Jakub Bogusz <qboosh@pld-linux.org> e53ead7
- release 2

* Mon Mar 18 2024 Jakub Bogusz <qboosh@pld-linux.org> 186a316
- added git fixes for xen and binutils 2.41+

* Sun Mar 17 2024 Jakub Bogusz <qboosh@pld-linux.org> d5e928e
- updated to 2.0.28

* Fri Sep 01 2023 Jakub Bogusz <qboosh@pld-linux.org> 980c954
- updated to 2.0.27

* Sun Jan 15 2023 Jakub Bogusz <qboosh@pld-linux.org> 6c37f2e
- updated to 2.0.26

* Fri Oct 07 2022 Jakub Bogusz <qboosh@pld-linux.org> b9035d2
- release 2 (xen 4.16)

* Sat Aug 20 2022 Jakub Bogusz <qboosh@pld-linux.org> c7b24b8
- updated to 2.0.25

* Thu Jun 16 2022 Jakub Bogusz <qboosh@pld-linux.org> 10b6ea3
- release 3 (xen soname change)

* Sat Jun 11 2022 Jan Rękorajski <baggins@pld-linux.org> 0f1071c
- Release 2 (by relup.sh)

* Sat May 07 2022 Jakub Bogusz <qboosh@pld-linux.org> b5afc86
- updated to 2.0.24

* Sun Nov 07 2021 Jakub Bogusz <qboosh@pld-linux.org> 65d680d
- updated to 2.0.23

* Sat May 08 2021 Jakub Bogusz <qboosh@pld-linux.org> bbcfec3
- updated to 2.0.22

* Wed Feb 24 2021 Jakub Bogusz <qboosh@pld-linux.org> 9a29d6a
- removed obsolete xen patch; release 2

* Mon Feb 22 2021 Jakub Bogusz <qboosh@pld-linux.org> f124e8d
- updated to 2.0.21
- updated x32 patch (only syscall number part left)
- removed obsolete fix-broken-multiboot2-buliding-for-i386,gcc10 patches

* Sun Jun 07 2020 Jan Rękorajski <baggins@pld-linux.org> 5940aa0
- fix building with gcc 10.x, rel 3

